
## groupCalcPctReport.sh script
##	calculates percentiles for interfaces in a group for previous month
## 	input: file name with list of group names
## 	output: file name with percentile output per group
##	groupCalcPctReport.sh groupList.csv report.csv
##
#       v1.0    September 2017, Lutz Holzbecher
#
# DISCLAIMER
# This script is provided AS IS and no warranties are provided or made.
# For more information refer to http://www.ca.com/us/legal/terms-for-user-sites.aspx
#
## INPUT PARAMETERS: set variables ==============================================================================
DA='DAHOST'
CRED='admin:admin'
## INPUT PARAMETERS: set variables ==============================================================================

if [ $# -lt 2	 ]
then
    echo "USAGE $0 <groupListInputFile> <reportOutputFile>"
    exit
fi
INFILE=$1
OUTFILE=$2
# setup URL
URL='http://'
URL+=$DA
URL+=':8581/odata/api/'
COUNTURL=$URL
COUNTURL+='interfaces/$count'
GROUPURL=$URL
GROUPURL+='groups'

# setup start and endtime
ymb4=$(date -d "1 month ago" "+%Y-%m")
startts=$(date -d "${ymb4}-01" "+%s")

ym=$(date "+%Y-%m-01")
end=$(date -d "$ym - 1 day" "+%Y-%m-%d 23:55")
endts=$(date -d "$end" "+%s")
TIMERANGE="&starttime=$startts&endtime=$endts"
echo Calculating Percentiles for timerange 
echo START = `date -d @$startts`
echo   END = `date -d @$endts`
echo "Group,Ports,Max-In,Max-Out,95%-In,95%-Out,98%-In,98%-Out" > $OUTFILE
{
    while IFS=, read -r Group
    do
	## calculate starttime/endtime

	#echo $Group, $TIMERANGE
	COUNTPARAM='$filter=((device/ID%20ne%200)%20and%20(groups/Name%20eq%20%27'
	COUNTPARAM+=$Group
	COUNTPARAM+='%27))'
	#echo $COUNTPARAM

	COUNT=`curl -u $CRED -s -G -X GET -d $COUNTPARAM $COUNTURL`
	echo Group=$Group, Ports=$COUNT

	APPLY='$apply=groupby(portmfs/Timestamp,%20aggregate(portmfs(im_BitsPerSecondIn%20with%20sum%20as%20im_BitsPerSecondIn,%20im_BitsPerSecondOut%20with%20sum%20as%20im_BitsPerSecondOut)))&$format=text/csv&&resolution=RATE'
	SELECT='&$top=1&$skip=0&top=10000&$select=Name&$filter=((Name%20eq%20%27'
	SELECT+=$Group
	SELECT+='%27))'
	PARAM="$APPLY$TIMERANGE$SELECT"
	#echo $PARAM
	curl -u $CRED -s -G -X GET -d $PARAM $GROUPURL > temp.csv
	perl groupCalcPct.pl temp.csv $COUNT $OUTFILE

    done
} < $INFILE

